# Class Server

This class is used to create a TCP or `IPC` server.

#### Since

v0.1.90

#### Hierarchy

- EventEmitter
  - Server
    - Server
    - Server

#####
Index

### Constructors

constructor

### Properties

connections
listening
maxConnections
captureRejectionSymbol
captureRejections
defaultMaxListeners
errorMonitor

### Methods

[asyncDispose]
[captureRejectionSymbol]?
addListener
address
close
emit
eventNames
getConnections
getMaxListeners
listen
listenerCount
listeners
off
on
once
prependListener
prependOnceListener
rawListeners
ref
removeAllListeners
removeListener
setMaxListeners
unref
addAbortListener
getEventListeners
getMaxListeners
listenerCount
on
once
setMaxListeners

## Constructors

### constructor

- new Server(connectionListener?): Server

- #### Parameters

  - ##### `Optional` connectionListener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.constructor

- new Server(options?, connectionListener?): Server

- #### Parameters

  - ##### `Optional` options: ServerOpts

  - ##### `Optional` connectionListener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.constructor

## Properties

### connections

connections: number

### `Readonly` listening

listening: boolean

Indicates whether or not the server is listening for connections.

#### Since

v5.7.0

### maxConnections

maxConnections: number

Set this property to reject connections when the server's connection count gets high.

It is not recommended to use this option once a socket has been sent to a child with `child_process.fork()`.

#### Since

v0.2.0

### `Static` `Readonly` captureRejectionSymbol

captureRejectionSymbol: typeof captureRejectionSymbol

Value: `Symbol.for('nodejs.rejection')`

See how to write a custom `rejection handler`.

#### Since

v13.4.0, v12.16.0

Inherited from EventEmitter.captureRejectionSymbol

### `Static` captureRejections

captureRejections: boolean

Value: boolean

Change the default `captureRejections` option on all new `EventEmitter` objects.

#### Since

v13.4.0, v12.16.0

Inherited from EventEmitter.captureRejections

### `Static` defaultMaxListeners

defaultMaxListeners: number

By default, a maximum of `10` listeners can be registered for any single event. This limit can be changed for individual `EventEmitter` instances using the `emitter.setMaxListeners(n)` method. To change the default for all `EventEmitter` instances, the `events.defaultMaxListeners`property can be used. If this value is not a positive number, a `RangeError`is thrown.

Take caution when setting the `events.defaultMaxListeners` because the change affects all `EventEmitter` instances, including those created before the change is made. However, calling `emitter.setMaxListeners(n)` still has precedence over `events.defaultMaxListeners`.

This is not a hard limit. The `EventEmitter` instance will allow more listeners to be added but will output a trace warning to stderr indicating that a "possible EventEmitter memory leak" has been detected. For any single`EventEmitter`, the `emitter.getMaxListeners()` and `emitter.setMaxListeners()`methods can be used to temporarily avoid this warning:

    import { EventEmitter } from 'node:events';
    const emitter = new EventEmitter();
    emitter.setMaxListeners(emitter.getMaxListeners() + 1);
    emitter.once('event', () => {
      // do stuff
      emitter.setMaxListeners(Math.max(emitter.getMaxListeners() - 1, 0));
    });

The `--trace-warnings` command-line flag can be used to display the stack trace for such warnings.

The emitted warning can be inspected with `process.on('warning')` and will have the additional `emitter`, `type`, and `count` properties, referring to the event emitter instance, the event's name and the number of attached listeners, respectively. Its `name` property is set to `'MaxListenersExceededWarning'`.

#### Since

v0.11.2

Inherited from EventEmitter.defaultMaxListeners

### `Static` `Readonly` errorMonitor

errorMonitor: typeof errorMonitor

This symbol shall be used to install a listener for only monitoring `'error'`events. Listeners installed using this symbol are called before the regular`'error'` listeners are called.

Installing a listener using this symbol does not change the behavior once an`'error'` event is emitted. Therefore, the process will still crash if no regular `'error'` listener is installed.

#### Since

v13.6.0, v12.17.0

Inherited from EventEmitter.errorMonitor

## Methods

### [asyncDispose]

- [asyncDispose](): Promise<void>

- Calls () and returns a promise that fulfills when the server has closed.

  #### Returns Promise<void>

  #### Since

  v20.5.0

### `Optional` [captureRejectionSymbol]

- [captureRejectionSymbol](error, event, ...args): void

- #### Parameters

  - ##### error: Error

  - ##### event: string

  - ##### `Rest` ...args: any[]

  #### Returns void

  Inherited from EventEmitter.[captureRejectionSymbol]

### addListener

- addListener(event, listener): Server

- events.EventEmitter

  1. close
  2. connection
  3. error
  4. listening
  5. drop

  #### Parameters

  - ##### event: string

  - ##### listener: ((...args) => void)

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

- addListener(event, listener): Server

- #### Parameters

  - ##### event: "close"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

- addListener(event, listener): Server

- #### Parameters

  - ##### event: "connection"

  - ##### listener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

- addListener(event, listener): Server

- #### Parameters

  - ##### event: "error"

  - ##### listener: ((err) => void)

    - - (err): void

      - #### Parameters

        - ##### err: Error

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

- addListener(event, listener): Server

- #### Parameters

  - ##### event: "listening"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

- addListener(event, listener): Server

- #### Parameters

  - ##### event: "drop"

  - ##### listener: ((data?) => void)

    - - (data?): void

      - #### Parameters

        - ##### `Optional` data: DropArgument

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.addListener

### address

- address(): null | string | AddressInfo

- Returns the bound `address`, the address `family` name, and `port` of the server as reported by the operating system if listening on an IP socket (useful to find which port was assigned when getting an OS-assigned address):`{ port: 12346, family: 'IPv4', address: '127.0.0.1' }`.

  For a server listening on a pipe or Unix domain socket, the name is returned as a string.

      const server = net.createServer((socket) => {
        socket.end('goodbye\n');
      }).on('error', (err) => {
        // Handle errors here.
        throw err;
      });

      // Grab an arbitrary unused port.
      server.listen(() => {
        console.log('opened server on', server.address());
      });

  `server.address()` returns `null` before the `'listening'` event has been emitted or after calling `server.close()`.

  #### Returns null | string | AddressInfo

  #### Since

  v0.1.90

### close

- close(callback?): Server

- Stops the server from accepting new connections and keeps existing connections. This function is asynchronous, the server is finally closed when all connections are ended and the server emits a `'close'` event. The optional `callback` will be called once the `'close'` event occurs. Unlike that event, it will be called with an `Error` as its only argument if the server was not open when it was closed.

  #### Parameters

  - ##### `Optional` callback: ((err?) => void)

    Called when the server is closed.

    - - (err?): void

      - #### Parameters

        - ##### `Optional` err: Error

        #### Returns void

  #### Returns Server

  #### Since

  v0.1.90

### emit

- emit(event, ...args): boolean

- Synchronously calls each of the listeners registered for the event named`eventName`, in the order they were registered, passing the supplied arguments to each.

  Returns `true` if the event had listeners, `false` otherwise.

      import { EventEmitter } from 'node:events';
      const myEmitter = new EventEmitter();

      // First listener
      myEmitter.on('event', function firstListener() {
        console.log('Helloooo! first listener');
      });
      // Second listener
      myEmitter.on('event', function secondListener(arg1, arg2) {
        console.log(`event with parameters ${arg1}, ${arg2} in second listener`);
      });
      // Third listener
      myEmitter.on('event', function thirdListener(...args) {
        const parameters = args.join(', ');
        console.log(`event with parameters ${parameters} in third listener`);
      });

      console.log(myEmitter.listeners('event'));

      myEmitter.emit('event', 1, 2, 3, 4, 5);

      // Prints:
      // [
      //   [Function: firstListener],
      //   [Function: secondListener],
      //   [Function: thirdListener]
      // ]
      // Helloooo! first listener
      // event with parameters 1, 2 in second listener
      // event with parameters 1, 2, 3, 4, 5 in third listener

  #### Parameters

  - ##### event: string | symbol

  - ##### `Rest` ...args: any[]

  #### Returns boolean

  #### Since

  v0.1.26

  Overrides EventEmitter.emit

- emit(event): boolean

- #### Parameters

  - ##### event: "close"

  #### Returns boolean

  Overrides EventEmitter.emit

- emit(event, socket): boolean

- #### Parameters

  - ##### event: "connection"

  - ##### socket: Socket

  #### Returns boolean

  Overrides EventEmitter.emit

- emit(event, err): boolean

- #### Parameters

  - ##### event: "error"

  - ##### err: Error

  #### Returns boolean

  Overrides EventEmitter.emit

- emit(event): boolean

- #### Parameters

  - ##### event: "listening"

  #### Returns boolean

  Overrides EventEmitter.emit

- emit(event, data?): boolean

- #### Parameters

  - ##### event: "drop"

  - ##### `Optional` data: DropArgument

  #### Returns boolean

  Overrides EventEmitter.emit

### eventNames

- eventNames(): (string | symbol)[]

- Returns an array listing the events for which the emitter has registered listeners. The values in the array are strings or `Symbol`s.

      import { EventEmitter } from 'node:events';

      const myEE = new EventEmitter();
      myEE.on('foo', () => {});
      myEE.on('bar', () => {});

      const sym = Symbol('symbol');
      myEE.on(sym, () => {});

      console.log(myEE.eventNames());
      // Prints: [ 'foo', 'bar', Symbol(symbol) ]

  #### Returns (string | symbol)[]

  #### Since

  v6.0.0

  Inherited from EventEmitter.eventNames

### getConnections

- getConnections(cb): void

- Asynchronously get the number of concurrent connections on the server. Works when sockets were sent to forks.

  Callback should take two arguments `err` and `count`.

  #### Parameters

  - ##### cb: ((error, count) => void)

    - - (error, count): void

      - #### Parameters

        - ##### error: null | Error

        - ##### count: number

        #### Returns void

  #### Since

  v0.9.7

### getMaxListeners

- getMaxListeners(): number

- Returns the current max listener value for the `EventEmitter` which is either set by `emitter.setMaxListeners(n)` or defaults to defaultMaxListeners.

  #### Returns number

  #### Since

  v1.0.0

  Inherited from EventEmitter.getMaxListeners

### listen

- listen(port?, hostname?, backlog?, listeningListener?): Server

- Start a server listening for connections. A `net.Server` can be a TCP or an `IPC` server depending on what it listens to.

  Possible signatures:

  - `server.listen(handle[, backlog][, callback])`
  - `server.listen(options[, callback])`
  - `server.listen(path[, backlog][, callback])` for `IPC` servers
  - `server.listen([port[, host[, backlog]]][, callback])` for TCP servers

  This function is asynchronous. When the server starts listening, the `'listening'` event will be emitted. The last parameter `callback`will be added as a listener for the `'listening'` event.

  All `listen()` methods can take a `backlog` parameter to specify the maximum length of the queue of pending connections. The actual length will be determined by the OS through sysctl settings such as `tcp_max_syn_backlog` and `somaxconn`on Linux. The default value of this parameter is 511 (not 512).

  All Socket are set to `SO_REUSEADDR` (see `socket(7)` for details).

  The `server.listen()` method can be called again if and only if there was an error during the first `server.listen()` call or `server.close()` has been called. Otherwise, an `ERR_SERVER_ALREADY_LISTEN` error will be thrown.

  One of the most common errors raised when listening is `EADDRINUSE`. This happens when another server is already listening on the requested`port`/`path`/`handle`. One way to handle this would be to retry after a certain amount of time:

      server.on('error', (e) => {
        if (e.code === 'EADDRINUSE') {
          console.error('Address in use, retrying...');
          setTimeout(() => {
            server.close();
            server.listen(PORT, HOST);
          }, 1000);
        }
      });

  #### Parameters

  - ##### `Optional` port: number

  - ##### `Optional` hostname: string

  - ##### `Optional` backlog: number

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(port?, hostname?, listeningListener?): Server

- #### Parameters

  - ##### `Optional` port: number

  - ##### `Optional` hostname: string

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(port?, backlog?, listeningListener?): Server

- #### Parameters

  - ##### `Optional` port: number

  - ##### `Optional` backlog: number

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(port?, listeningListener?): Server

- #### Parameters

  - ##### `Optional` port: number

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(path, backlog?, listeningListener?): Server

- #### Parameters

  - ##### path: string

  - ##### `Optional` backlog: number

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(path, listeningListener?): Server

- #### Parameters

  - ##### path: string

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(options, listeningListener?): Server

- #### Parameters

  - ##### options: ListenOptions

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(handle, backlog?, listeningListener?): Server

- #### Parameters

  - ##### handle: any

  - ##### `Optional` backlog: number

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

- listen(handle, listeningListener?): Server

- #### Parameters

  - ##### handle: any

  - ##### `Optional` listeningListener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

### listenerCount

- listenerCount(eventName, listener?): number

- Returns the number of listeners listening for the event named `eventName`. If `listener` is provided, it will return how many times the listener is found in the list of the listeners of the event.

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event being listened for

  - ##### `Optional` listener: Function

    The event handler function

  #### Returns number

  #### Since

  v3.2.0

  Inherited from EventEmitter.listenerCount

### listeners

- listeners(eventName): Function[]

- Returns a copy of the array of listeners for the event named `eventName`.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });
      console.log(util.inspect(server.listeners('connection')));
      // Prints: [ [Function] ]

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

  #### Since

  v0.1.26

  Inherited from EventEmitter.listeners

### off

- off(eventName, listener): Server

- Alias for `emitter.removeListener()`.

  #### Parameters

  - ##### eventName: string | symbol

  - ##### listener: ((...args) => void)

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v10.0.0

  Inherited from EventEmitter.off

### on

- on(event, listener): Server

- Adds the `listener` function to the end of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      import { EventEmitter } from 'node:events';
      const myEE = new EventEmitter();
      myEE.on('foo', () => console.log('a'));
      myEE.prependListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: string

    The name of the event.

  - ##### listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v0.1.101

  Overrides EventEmitter.on

- on(event, listener): Server

- #### Parameters

  - ##### event: "close"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.on

- on(event, listener): Server

- #### Parameters

  - ##### event: "connection"

  - ##### listener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.on

- on(event, listener): Server

- #### Parameters

  - ##### event: "error"

  - ##### listener: ((err) => void)

    - - (err): void

      - #### Parameters

        - ##### err: Error

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.on

- on(event, listener): Server

- #### Parameters

  - ##### event: "listening"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.on

- on(event, listener): Server

- #### Parameters

  - ##### event: "drop"

  - ##### listener: ((data?) => void)

    - - (data?): void

      - #### Parameters

        - ##### `Optional` data: DropArgument

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.on

### once

- once(event, listener): Server

- Adds a one-time `listener` function for the event named `eventName`. The next time `eventName` is triggered, this listener is removed and then invoked.

      server.once('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependOnceListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      import { EventEmitter } from 'node:events';
      const myEE = new EventEmitter();
      myEE.once('foo', () => console.log('a'));
      myEE.prependOnceListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: string

    The name of the event.

  - ##### listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v0.3.0

  Overrides EventEmitter.once

- once(event, listener): Server

- #### Parameters

  - ##### event: "close"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.once

- once(event, listener): Server

- #### Parameters

  - ##### event: "connection"

  - ##### listener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.once

- once(event, listener): Server

- #### Parameters

  - ##### event: "error"

  - ##### listener: ((err) => void)

    - - (err): void

      - #### Parameters

        - ##### err: Error

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.once

- once(event, listener): Server

- #### Parameters

  - ##### event: "listening"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.once

- once(event, listener): Server

- #### Parameters

  - ##### event: "drop"

  - ##### listener: ((data?) => void)

    - - (data?): void

      - #### Parameters

        - ##### `Optional` data: DropArgument

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.once

### prependListener

- prependListener(event, listener): Server

- Adds the `listener` function to the beginning of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.prependListener('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: string

    The name of the event.

  - ##### listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v6.0.0

  Overrides EventEmitter.prependListener

- prependListener(event, listener): Server

- #### Parameters

  - ##### event: "close"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependListener

- prependListener(event, listener): Server

- #### Parameters

  - ##### event: "connection"

  - ##### listener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependListener

- prependListener(event, listener): Server

- #### Parameters

  - ##### event: "error"

  - ##### listener: ((err) => void)

    - - (err): void

      - #### Parameters

        - ##### err: Error

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependListener

- prependListener(event, listener): Server

- #### Parameters

  - ##### event: "listening"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependListener

- prependListener(event, listener): Server

- #### Parameters

  - ##### event: "drop"

  - ##### listener: ((data?) => void)

    - - (data?): void

      - #### Parameters

        - ##### `Optional` data: DropArgument

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependListener

### prependOnceListener

- prependOnceListener(event, listener): Server

- Adds a one-time `listener` function for the event named `eventName` to the beginning of the listeners array. The next time `eventName` is triggered, this listener is removed, and then invoked.

      server.prependOnceListener('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: string

    The name of the event.

  - ##### listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v6.0.0

  Overrides EventEmitter.prependOnceListener

- prependOnceListener(event, listener): Server

- #### Parameters

  - ##### event: "close"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependOnceListener

- prependOnceListener(event, listener): Server

- #### Parameters

  - ##### event: "connection"

  - ##### listener: ((socket) => void)

    - - (socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependOnceListener

- prependOnceListener(event, listener): Server

- #### Parameters

  - ##### event: "error"

  - ##### listener: ((err) => void)

    - - (err): void

      - #### Parameters

        - ##### err: Error

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependOnceListener

- prependOnceListener(event, listener): Server

- #### Parameters

  - ##### event: "listening"

  - ##### listener: (() => void)

    - - (): void

      - #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependOnceListener

- prependOnceListener(event, listener): Server

- #### Parameters

  - ##### event: "drop"

  - ##### listener: ((data?) => void)

    - - (data?): void

      - #### Parameters

        - ##### `Optional` data: DropArgument

        #### Returns void

  #### Returns Server

  Overrides EventEmitter.prependOnceListener

### rawListeners

- rawListeners(eventName): Function[]

- Returns a copy of the array of listeners for the event named `eventName`, including any wrappers (such as those created by `.once()`).

      import { EventEmitter } from 'node:events';
      const emitter = new EventEmitter();
      emitter.once('log', () => console.log('log once'));

      // Returns a new Array with a function `onceWrapper` which has a property
      // `listener` which contains the original listener bound above
      const listeners = emitter.rawListeners('log');
      const logFnWrapper = listeners[0];

      // Logs "log once" to the console and does not unbind the `once` event
      logFnWrapper.listener();

      // Logs "log once" to the console and removes the listener
      logFnWrapper();

      emitter.on('log', () => console.log('log persistently'));
      // Will return a new Array with a single function bound by `.on()` above
      const newListeners = emitter.rawListeners('log');

      // Logs "log persistently" twice
      newListeners[0]();
      emitter.emit('log');

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

  #### Since

  v9.4.0

  Inherited from EventEmitter.rawListeners

### ref

- ref(): Server

- Opposite of `unref()`, calling `ref()` on a previously `unref`ed server will not let the program exit if it's the only server left (the default behavior). If the server is `ref`ed calling `ref()` again will have no effect.

  #### Returns Server

  #### Since

  v0.9.1

### removeAllListeners

- removeAllListeners(event?): Server

- Removes all listeners, or those of the specified `eventName`.

  It is bad practice to remove listeners added elsewhere in the code, particularly when the `EventEmitter` instance was created by some other component or module (e.g. sockets or file streams).

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### `Optional` event: string | symbol

  #### Returns Server

  #### Since

  v0.1.26

  Inherited from EventEmitter.removeAllListeners

### removeListener

- removeListener(eventName, listener): Server

- Removes the specified `listener` from the listener array for the event named`eventName`.

      const callback = (stream) => {
        console.log('someone connected!');
      };
      server.on('connection', callback);
      // ...
      server.removeListener('connection', callback);

  `removeListener()` will remove, at most, one instance of a listener from the listener array. If any single listener has been added multiple times to the listener array for the specified `eventName`, then `removeListener()` must be called multiple times to remove each instance.

  Once an event is emitted, all listeners attached to it at the time of emitting are called in order. This implies that any`removeListener()` or `removeAllListeners()` calls after emitting and before the last listener finishes execution will not remove them from`emit()` in progress. Subsequent events behave as expected.

      import { EventEmitter } from 'node:events';
      class MyEmitter extends EventEmitter {}
      const myEmitter = new MyEmitter();

      const callbackA = () => {
        console.log('A');
        myEmitter.removeListener('event', callbackB);
      };

      const callbackB = () => {
        console.log('B');
      };

      myEmitter.on('event', callbackA);

      myEmitter.on('event', callbackB);

      // callbackA removes listener callbackB but it will still be called.
      // Internal listener array at time of emit [callbackA, callbackB]
      myEmitter.emit('event');
      // Prints:
      //   A
      //   B

      // callbackB is now removed.
      // Internal listener array [callbackA]
      myEmitter.emit('event');
      // Prints:
      //   A

  Because listeners are managed using an internal array, calling this will change the position indices of any listener registered after the listener being removed. This will not impact the order in which listeners are called, but it means that any copies of the listener array as returned by the `emitter.listeners()` method will need to be recreated.

  When a single function has been added as a handler multiple times for a single event (as in the example below), `removeListener()` will remove the most recently added instance. In the example the `once('ping')`listener is removed:

      import { EventEmitter } from 'node:events';
      const ee = new EventEmitter();

      function pong() {
        console.log('pong');
      }

      ee.on('ping', pong);
      ee.once('ping', pong);
      ee.removeListener('ping', pong);

      ee.emit('ping');
      ee.emit('ping');

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### eventName: string | symbol

  - ##### listener: ((...args) => void)

    - - (...args): void

      - #### Parameters

        - ##### `Rest` ...args: any[]

        #### Returns void

  #### Returns Server

  #### Since

  v0.1.26

  Inherited from EventEmitter.removeListener

### setMaxListeners

- setMaxListeners(n): Server

- By default `EventEmitter`s will print a warning if more than `10` listeners are added for a particular event. This is a useful default that helps finding memory leaks. The `emitter.setMaxListeners()` method allows the limit to be modified for this specific `EventEmitter` instance. The value can be set to`Infinity` (or `0`) to indicate an unlimited number of listeners.

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### n: number

  #### Returns Server

  #### Since

  v0.3.5

  Inherited from EventEmitter.setMaxListeners

### unref

- unref(): Server

- Calling `unref()` on a server will allow the program to exit if this is the only active server in the event system. If the server is already `unref`ed calling`unref()` again will have no effect.

  #### Returns Server

  #### Since

  v0.9.1

### `Static` addAbortListener

- addAbortListener(signal, resource): Disposable
- `Experimental`

  Listens once to the `abort` event on the provided `signal`.

  Listening to the `abort` event on abort signals is unsafe and may lead to resource leaks since another third party with the signal can call `e.stopImmediatePropagation()`. Unfortunately Node.js cannot change this since it would violate the web standard. Additionally, the original API makes it easy to forget to remove listeners.

  This API allows safely using `AbortSignal`s in Node.js APIs by solving these two issues by listening to the event such that `stopImmediatePropagation` does not prevent the listener from running.

  Returns a disposable so that it may be unsubscribed from more easily.

      import { addAbortListener } from 'node:events';

      function example(signal) {
        let disposable;
        try {
          signal.addEventListener('abort', (e) => e.stopImmediatePropagation());
          disposable = addAbortListener(signal, (e) => {
            // Do something when signal is aborted.
          });
        } finally {
          disposable?.[Symbol.dispose]();
        }
      }

  #### Parameters

  - ##### signal: AbortSignal

  - ##### resource: ((event) => void)

    - - (event): void

      - #### Parameters

        - ##### event: Event

        #### Returns void

  #### Returns Disposable

  Disposable that removes the `abort` listener.

  #### Since

  v20.5.0

  Inherited from EventEmitter.addAbortListener

### `Static` getEventListeners

- getEventListeners(emitter, name): Function[]

- Returns a copy of the array of listeners for the event named `eventName`.

  For `EventEmitter`s this behaves exactly the same as calling `.listeners` on the emitter.

  For `EventTarget`s this is the only way to get the event listeners for the event target. This is useful for debugging and diagnostic purposes.

      import { getEventListeners, EventEmitter } from 'node:events';

      {
        const ee = new EventEmitter();
        const listener = () => console.log('Events are fun');
        ee.on('foo', listener);
        console.log(getEventListeners(ee, 'foo')); // [ [Function: listener] ]
      }
      {
        const et = new EventTarget();
        const listener = () => console.log('Events are fun');
        et.addEventListener('foo', listener);
        console.log(getEventListeners(et, 'foo')); // [ [Function: listener] ]
      }

  #### Parameters

  - ##### emitter: EventEmitter | _DOMEventTarget

  - ##### name: string | symbol

  #### Returns Function[]

  #### Since

  v15.2.0, v14.17.0

  Inherited from EventEmitter.getEventListeners

### `Static` getMaxListeners

- getMaxListeners(emitter): number

- Returns the currently set max amount of listeners.

  For `EventEmitter`s this behaves exactly the same as calling `.getMaxListeners` on the emitter.

  For `EventTarget`s this is the only way to get the max event listeners for the event target. If the number of event handlers on a single EventTarget exceeds the max set, the EventTarget will print a warning.

      import { getMaxListeners, setMaxListeners, EventEmitter } from 'node:events';

      {
        const ee = new EventEmitter();
        console.log(getMaxListeners(ee)); // 10
        setMaxListeners(11, ee);
        console.log(getMaxListeners(ee)); // 11
      }
      {
        const et = new EventTarget();
        console.log(getMaxListeners(et)); // 10
        setMaxListeners(11, et);
        console.log(getMaxListeners(et)); // 11
      }

  #### Parameters

  - ##### emitter: EventEmitter | _DOMEventTarget

  #### Returns number

  #### Since

  v19.9.0

  Inherited from EventEmitter.getMaxListeners

### `Static` listenerCount

- listenerCount(emitter, eventName): number

- A class method that returns the number of listeners for the given `eventName`registered on the given `emitter`.

      import { EventEmitter, listenerCount } from 'node:events';

      const myEmitter = new EventEmitter();
      myEmitter.on('event', () => {});
      myEmitter.on('event', () => {});
      console.log(listenerCount(myEmitter, 'event'));
      // Prints: 2

  #### Parameters

  - ##### emitter: EventEmitter

    The emitter to query

  - ##### eventName: string | symbol

    The event name

  #### Returns number

  #### Since

  v0.9.12

  #### Deprecated

  Since v3.2.0 - Use `listenerCount` instead.

  Inherited from EventEmitter.listenerCount

### `Static` on

- on(emitter, eventName, options?): AsyncIterableIterator<any, any, any>

-     import { on, EventEmitter } from 'node:events';
      import process from 'node:process';

      const ee = new EventEmitter();

      // Emit later on
      process.nextTick(() => {
        ee.emit('foo', 'bar');
        ee.emit('foo', 42);
      });

      for await (const event of on(ee, 'foo')) {
        // The execution of this inner block is synchronous and it
        // processes one event at a time (even with await). Do not use
        // if concurrent execution is required.
        console.log(event); // prints ['bar'] [42]
      }
      // Unreachable here

  Returns an `AsyncIterator` that iterates `eventName` events. It will throw if the `EventEmitter` emits `'error'`. It removes all listeners when exiting the loop. The `value` returned by each iteration is an array composed of the emitted event arguments.

  An `AbortSignal` can be used to cancel waiting on events:

      import { on, EventEmitter } from 'node:events';
      import process from 'node:process';

      const ac = new AbortController();

      (async () => {
        const ee = new EventEmitter();

        // Emit later on
        process.nextTick(() => {
          ee.emit('foo', 'bar');
          ee.emit('foo', 42);
        });

        for await (const event of on(ee, 'foo', { signal: ac.signal })) {
          // The execution of this inner block is synchronous and it
          // processes one event at a time (even with await). Do not use
          // if concurrent execution is required.
          console.log(event); // prints ['bar'] [42]
        }
        // Unreachable here
      })();

      process.nextTick(() => ac.abort());

  #### Parameters

  - ##### emitter: EventEmitter

  - ##### eventName: string

    The name of the event being listened for

  - ##### `Optional` options: StaticEventEmitterOptions

  #### Returns AsyncIterableIterator<any, any, any>

  that iterates `eventName` events emitted by the `emitter`

  #### Since

  v13.6.0, v12.16.0

  Inherited from EventEmitter.on

### `Static` once

- once(emitter, eventName, options?): Promise<any[]>

- Creates a `Promise` that is fulfilled when the `EventEmitter` emits the given event or that is rejected if the `EventEmitter` emits `'error'` while waiting. The `Promise` will resolve with an array of all the arguments emitted to the given event.

  This method is intentionally generic and works with the web platform EventTarget interface, which has no special`'error'` event semantics and does not listen to the `'error'` event.

      import { once, EventEmitter } from 'node:events';
      import process from 'node:process';

      const ee = new EventEmitter();

      process.nextTick(() => {
        ee.emit('myevent', 42);
      });

      const [value] = await once(ee, 'myevent');
      console.log(value);

      const err = new Error('kaboom');
      process.nextTick(() => {
        ee.emit('error', err);
      });

      try {
        await once(ee, 'myevent');
      } catch (err) {
        console.error('error happened', err);
      }

  The special handling of the `'error'` event is only used when `events.once()`is used to wait for another event. If `events.once()` is used to wait for the '`error'` event itself, then it is treated as any other kind of event without special handling:

      import { EventEmitter, once } from 'node:events';

      const ee = new EventEmitter();

      once(ee, 'error')
        .then(([err]) => console.log('ok', err.message))
        .catch((err) => console.error('error', err.message));

      ee.emit('error', new Error('boom'));

      // Prints: ok boom

  An `AbortSignal` can be used to cancel waiting for the event:

      import { EventEmitter, once } from 'node:events';

      const ee = new EventEmitter();
      const ac = new AbortController();

      async function foo(emitter, event, signal) {
        try {
          await once(emitter, event, { signal });
          console.log('event emitted!');
        } catch (error) {
          if (error.name === 'AbortError') {
            console.error('Waiting for the event was canceled!');
          } else {
            console.error('There was an error', error.message);
          }
        }
      }

      foo(ee, 'foo', ac.signal);
      ac.abort(); // Abort waiting for the event
      ee.emit('foo'); // Prints: Waiting for the event was canceled!

  #### Parameters

  - ##### emitter: _NodeEventTarget

  - ##### eventName: string | symbol

  - ##### `Optional` options: StaticEventEmitterOptions

  #### Returns Promise<any[]>

  #### Since

  v11.13.0, v10.16.0

  Inherited from EventEmitter.once

- once(emitter, eventName, options?): Promise<any[]>

- #### Parameters

  - ##### emitter: _DOMEventTarget

  - ##### eventName: string

  - ##### `Optional` options: StaticEventEmitterOptions

  #### Returns Promise<any[]>

  Inherited from EventEmitter.once

### `Static` setMaxListeners

- setMaxListeners(n?, ...eventTargets): void

-     import { setMaxListeners, EventEmitter } from 'node:events';

      const target = new EventTarget();
      const emitter = new EventEmitter();

      setMaxListeners(5, target, emitter);

  #### Parameters

  - ##### `Optional` n: number

    A non-negative number. The maximum number of listeners per `EventTarget` event.

  - ##### `Rest` ...eventTargets: (EventEmitter | _DOMEventTarget)[]

  #### Returns void

  #### Since

  v15.4.0

  Inherited from EventEmitter.setMaxListeners

Generated using TypeDoc